﻿Public Class ClassPreviewForm
    Sub SetForClass(c As ExportItem)
        Dim props = c.GetClassProperties()
        Dim defaults = c.GetClassDefaults(props)
        Dim defPtr = 0
        lvProps.BeginUpdate()
        lvProps.Items.Clear()
        For i = 0 To props.GetUpperBound(0)
            Dim item = lvProps.Items.Add(props(i).Name)

            Dim value = ""

            If props(i).ArraySize = 1 Or props(i).Type = EPropType.T_String Then
                value = defaults(defPtr).Value
                defPtr += 1
            Else
                value = "("
                For j = 0 To props(i).ArraySize - 1
                    value &= defaults(defPtr).Value
                    If j < props(i).ArraySize - 1 Then
                        value &= ","
                    End If
                    defPtr += 1
                Next
                value &= ")"
            End If

            item.SubItems.Add(value)
            item.SubItems.Add(props(i).Category)
            item.SubItems.Add(props(i).Type.ToString.Substring(2))
            item.SubItems.Add(props(i).Offset)
            item.SubItems.Add(ParsePropFlags(props(i).Flags))
            Dim arrSize As String = props(i).ArraySize
            If arrSize = "0" Then arrSize = ""
            item.SubItems.Add(arrSize)
            item.SubItems.Add(props(i).ElementSize)
            item.SubItems.Add(props(i).TotalSize)
            Dim misc = ""
            Select Case props(i).Type
                Case EPropType.T_Index
                    misc = TypeToName(props(i).Misc)
                Case EPropType.T_Byte, EPropType.T_Actor
                    misc = c.MyLevel.GetResName(props(i).Misc)
                    If misc = "None" Then misc = ""
                Case EPropType.T_Bool
                    misc = props(i).Misc
                Case Else
                    misc = props(i).Misc
                    If misc = "0" Then misc = ""
            End Select
            item.SubItems.Add(misc)
        Next
        lvProps.EndUpdate()
    End Sub

End Class