﻿Module Translation
    Dim PolyFlagsRemap As Integer() = {1, 2, 4, 8, 16, 32, 0, 128, 256, 512, 1024, 2048, 8192, 8192, 64, 32768, 65536, 128, 262144, 0, 1048576, 4, 4194304, 8388608, 0, 0, 67108865, 0, 1 << 28, 1 << 29, 1 << 30, 1 << 31}

    Function RemapPolyFlags(flags As Integer) As Integer
        Dim result As Integer = 0
        For i = 0 To 31
            If flags And (1 << i) Then
                result = result Or PolyFlagsRemap(i)
            End If
        Next
        Return result
    End Function

    Function ShouldIgnoreProperty(propName As String) As Boolean
        Select Case propName
            Case "CollisionRadius", "CollisionHeight", "User", "Stamina", "Me", "LifeState"
                Return True
            Case Else
                Return False
        End Select
    End Function

    Function RemapProperty(prop As ActorProperty) As ActorProperty
        Select Case prop.Name
            Case "EventName"
                prop.Name = "Event"
            Case "MoverTime"
                prop.Name = "MoveTime"
                prop.Value = NumToStr(StrToNum(prop.Value) / 35)
            Case "RemainOpenTime"
                prop.Name = "StayOpenTime"
                prop.Value = NumToStr(StrToNum(prop.Value) / 35)
            Case "Name"
                prop.Name = "Tag"
            Case "DrawRot"
                prop.Name = "Rotation"
            Case "LightEffect"
                If prop.Value = "LE_StormCast" Then
                    'approximation
                    prop.Value = "LE_Shock"
                End If
            Case "MoverTriggerType"
                prop.Name = "InitialState"
                Select Case prop.Value
                    Case "MT_None"
                        prop.Value = "None"
                    Case "MT_TriggerOpenTimed", "MT_TriggerCycleOn", "MT_TriggerCycleOff", "MT_TriggerInstant"
                        'approximation
                        prop.Value = "TriggerOpenTimed"
                    Case "MT_TriggerToggle"
                        prop.Value = "TriggerToggle"
                    Case "MT_TriggerControl"
                        prop.Value = "TriggerControl"
                    Case "MT_ProximityOpenTimed", "MT_ProximityControl"
                        'approximation
                        prop.Value = "BumpOpenTimed"
                    Case "MT_StandOpenTimed"
                        prop.Value = "StandOpenTimed"
                End Select
            Case "MoverBumpType"
                prop.Name = "MoverEncroachType"
                Select Case prop.Value
                    Case "MB_StopWhenBump"
                        prop.Value = "ME_StopWhenEncroach"
                    Case "MB_ReturnWhenBump"
                        prop.Value = "ME_ReturnWhenEncroach"
                    Case "MB_CrushWhenBump"
                        prop.Value = "ME_CrushWhenEncroach"
                End Select
        End Select

        Return prop
    End Function

End Module
